from infinishell.infishell import availability, command, config
from infinishell.infishell.utils import strlist

from ..utils import Version
from .system import system, Roles
from infinishell.infishell.exceptions import CommandFailed

def feature_command(**kwargs):
	def decorator(_func):
		feature = kwargs.pop('feature')
		status = kwargs.pop('status')
		return availability(command(_func, **kwargs), predicate=lambda: feature_exists(feature) if status else not feature_exists(feature))
	if kwargs.get('feature') is None or not isinstance(kwargs.get('status'), (bool)):
		raise CommandFailed("feature_command decorator requires feature and status parameters")
	return decorator

def feature_exists(feature=None):
	if feature == "iscsi":
		return True
	else:
		return (feature is not None and
				feature in config.get('feature_list', []) and
				config.feature_list[feature].get('enabled', False))
