from numbers import Integral

from .values import StorageCapacityRenderer

def render_capacity(size):
    size = size or 0
    if not isinstance(size, Integral):
        return size
    return StorageCapacityRenderer().render(size, "-")

CANONICAL_CASE = {
	'iscsi'  : 'iSCSI',
	'bbu'    : 'BBU',
	'ssd'    : 'SSD',
	'ssl'    : 'SSL',
	'snmp'   : 'SNMP',
	'id'     : 'ID',
	'wwnn'   : 'WWNN',
	'raid'   : 'RAID',
	'iqn'    : 'IQN',
	'ip'     : 'IP',
	'ips'    : 'IPs',
	'dns'    : 'DNS',
	'ntp'    : 'NTP',
	'fs'     : 'FS',
	'nfs'    : 'NFS',
	'ldaps'  : 'LDAPS',
	'basedn' : 'Base DN',
	'tcp'    : 'TCP',
	'mtu'    : 'MTU',
	'isns'   : 'ISNS',
	'chap'   : 'CHAP',
	'fc'     : 'FC',
	'luns'   : 'LUNs',
	'iqns'   : 'IQNs',
	'rpo'    : 'RPO',
	'cg'	 : 'CG',
	'mbps'   : 'Mbps',
	'ops'    : 'OPS',
	'sg'	 : 'SG',
	'qos'    : 'QoS',
	'snmp'   : 'SNMP',
	
}

CANONICAL_CASE_RE = '|'.join(CANONICAL_CASE.keys())
