import sys

PY2 = sys.version_info[0] == 2

if PY2:
    itervalues = lambda d: d.itervalues()
    iteritems = lambda d: d.iteritems()
    iterkeys = lambda d: d.iterkeys()
    raw_input = raw_input
    string_types = (basestring,)
    exec("""def reraise(err, value, tb):
         raise err, value, tb""")
    from contextlib import nested
    from itertools import izip
    xrange = xrange
    reduce = reduce

    def im_func(f):
        return f.im_func

    def assertItemsEqual(self, a, b):
        self.assertItemsEqual(a, b)

    exec("""def with_metaclass(meta):
    class _WithMetaclassBase(object):
        __metaclass__ = meta
    return _WithMetaclassBase
""")
    unicode = unicode
    def str_decode(s, encoding):
        return s.decode(encoding)

else:
    itervalues = lambda d: d.values()
    iteritems = lambda d: d.items()
    iterkeys = lambda d: d.keys()
    raw_input = input
    string_types = (str,)
    def reraise(err, value, tb):
        raise value.with_traceback(tb)

    from contextlib import ExitStack, contextmanager

    @contextmanager
    def nested(*args):
        with ExitStack() as stack:
            for context in args:
                stack.enter_context(context)

            yield stack

    izip = zip
    xrange = range
    from functools import reduce

    def im_func(f):
        return f

    def assertItemsEqual(self, a, b):
        self.assertCountEqual(a, b)

    exec("""def with_metaclass(meta):
    class _WithMetaclassBase(object, metaclass=meta):
        pass
    return _WithMetaclassBase
""")
    def unicode(s):
        if not isinstance(s, str):
            s = str(s)

        return s

    def str_decode(s, encoding):
        assert isinstance(s, str)
        return s
