# This module monkey-patches colorama so that errors during exit are not output
# to stdout/stderr. Such errors may occur when the output stream is truncated,
# e.g when piping the output to 'head'.

import colorama.initialise
import atexit

class _atexit(object):
    @staticmethod
    def register(func, *args, **kwargs):
        def _func_wrapper(*a, **kw):
            try: func(*a, **kw)
            except: pass
        atexit.register(_func_wrapper, *args, **kwargs)

colorama.initialise.atexit = _atexit
