import struct
import socket

def ip_to_int(ip):
    return struct.unpack("!I", socket.inet_aton(ip))[0]

def cidr_to_netmask(cidr):
    return socket.inet_ntoa(struct.pack('>I', 0xffffffff ^ (1 << 32 - int(cidr)) - 1))

def netmask_to_cidr(subnet):
    return sum([bin(int(x)).count('1') for x in subnet.split('.')])
