import re

_p1, _p2 = re.compile('(.)([A-Z][a-z]+)'), re.compile('([a-z0-9])([A-Z])')
_repl = r'\1 \2'
def decamelize(s):
    ''' Convert camel-cased string to a sentence, e.g ``MyGreat_LittleClass`` ->
    ``my great little class``. '''
    return _p2.sub(_repl, _p1.sub(_repl, s.replace("_", " "))).strip()

def normalize_sentence(s, end_with='.'):
    '''
    End sentence with a dot (or the specified custom character), if sentence
    does not end with any mark (dot, semicolon, question mark, etc').

    :param s: Sentence string
    :param end_with: Custom ending character
    '''
    if s is None:
        return None
    s = s.strip()
    if s[-1] not in '.?!:;':
        s += end_with
    return s
